import { MagicLibrary, GradeList, MagicTypes } from "./lib/MagicLibrary"; //you can copy MagicLibrary.js from lib folder to your script folder

//first thing you need to define magic library
var MagicLib = new MagicLibrary();

//then you could add your custom item to become magic casting weapon by defining like that
//for better compatibility your custom item should has chargeable component
let casting_item = MagicLib.addCastingWeapon("minecraft:iron_sword");
casting_item.cast_efficiency = 1.2;
casting_item.soul_efficiency = 0.1;
casting_item.fast_swap = true; // this statment to able to fast swap spell when sneak + right click

//you could make custom spellbook by doing something like that
//i reccomend you to add allow offhand component
let spellbook_item = MagicLib.addSpellBook("minecraft:shield");
spellbook_item.compatible_attributes = [
    "creation",
    "restoration",
    "conjuration",
    "destruction",
    "transmutation",
    "manipulation",
    "nature",
    "fire", 
    "void", 
    "dark",
    "water",
    "thunder",
    "wind",
    "light",
    "ice"
];
spellbook_item.incompatible_attributes = [];
spellbook_item.compatible_types = [
    MagicTypes.Create,
    MagicTypes.Action,
    MagicTypes.Summon,
    MagicTypes.Enchance,
    MagicTypes.Combat,
    MagicTypes.Curse
];
spellbook_item.grade = [ GradeList.Basic, GradeList.Master ];
spellbook_item.addPredefinedSpell("fire_bullet"); //this statement is to attach spell by default
spellbook_item.max_spell = 4;
spellbook_item.name = "Something called spellbook";

//this statement is to add attribute points for upgrade in magic reinforcement table
MagicLib.addAttributePoint("minecraft:brush", 10);
MagicLib.addAttributePoint("minecraft:shield", 3);

let predefine_casting_item = MagicLib.addPredefineAttributes("minecraft:brush");
predefine_casting_item.addAttribute("fire", 4);

let predefine_spellbook_item = MagicLib.addPredefineAttributes("minecraft:brush");
predefine_spellbook_item.addAttribute("fire", 1);

//this statement is to make new spell
let spell_test = MagicLib.addSpell("test_spell", "minecraft:stick");

spell_test.name = "Test Test Test";
spell_test.path = "textures/ui/magic_list/soul_devour";
spell_test.attribute = [ "transmutation", "destruction", "dark" ];
spell_test.grade = "expert";
spell_test.type = "curse";
spell_test.cast_duration = 37;
spell_test.soul_cost = 2;
spell_test.description = "this is test spell.";

spell_test.subscribe(s=>{
    s.source.runCommand("say test scroll acticated!");
    s.source.runCommand("say total soul is " + s.attributes.soul_capacity);
    // s.source.dimension.spawnEntity("husk", s.source.location).addTag("s")
    s.source.runCommand("summon husk aaa");
    console.warn(s.source.dimension.getEntities({name: "aaa"}))

})

MagicLib.send(); // at last dont forget to add this send statement