import { world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import * as SpellDB from "./spell_book_database";
import { getMagicData } from "./magic_list";

export function setFastSwap(source, spellSlot){
    let table = new ActionFormData();
    table.title('fast_swap_scroll.menu');

    for(let spell of SpellDB.getSpellData(spellSlot).spell){
        table.button(getMagicData()[spell].name, getMagicData()[spell].path)
    }
    
	table.body("menu.invisible");
    table.show(source).then(e=>{
        if(e.selection != undefined){
            SpellDB.setSpellSlot(spellSlot, e.selection);
            source.playSound("item.book.page_turn", { pitch: 1.1, volume: 1 });
        }
    })
}