import { system } from "@minecraft/server";
import { updateReinforcementTable } from "./magic_reinforcement_table";
import { NoveltyManager, AccessoriesSlot } from "./lib/NoveltyManager";
import { updateMagicLearningStation } from "./magic_learning_station";
import { importMagicData } from "./magic_list";
import { updateSpellRecipes } from "./spell_recipes";
import { updateSpellBindingTable } from "./spell_binding_table";

export var scroll = {"amw:none_scroll":"none","amw:recall_scroll":"recall","amw:scorching_ash_scroll":"scorching_ash","amw:magical_sword_scroll":"magical_sword","amw:blood_slash_scroll":"blood_slash","amw:snowflake_scroll":"snowflake","amw:blood_pool_scroll":"blood_pool","amw:blood_surge_scroll":"blood_surge","amw:illuminate_scroll":"illuminate","amw:soul_devour_scroll":"soul_devour","amw:thunder_step_scroll":"thunder_step","amw:blazing_trail_scroll":"blazing_trail","amw:dirt_wall_scroll":"dirt_wall","amw:absolute_area_scroll":"absolute_area","amw:fire_obelisk_scroll":"fire_obelisk","amw:fire_obelisk_area_scroll":"fire_obelisk_area","amw:decoy_obelisk_scroll":"decoy_obelisk","amw:levitate_scroll":"levitate","amw:water_fountain_scroll":"water_fountain","amw:aero_walk_scroll":"aero_walk","amw:explosion_scroll":"explosion","amw:devine_judgement_scroll":"devine_judgement","amw:sonic_boom_scroll":"sonic_boom","amw:mutation_vines_scroll":"mutation_vines","amw:self_healing_scroll":"self_healing","amw:devine_healing_scroll":"devine_healing","amw:aegis_scroll":"aegis","amw:magic_lasso_scroll":"magic_lasso","amw:magnetism_scroll":"magnetism","amw:soul_detection_scroll":"soul_detection","amw:book_of_healing_scroll":"book_of_healing","amw:blood_drain_scroll":"blood_drain","amw:thundering_scroll":"thundering","amw:cumulonimbus_scroll":"cumulonimbus","amw:turn_undead_scroll":"turn_undead","amw:magic_shield_scroll":"magic_shield","amw:area_heals_scroll":"area_heals","amw:healing_totem_scroll":"healing_totem","amw:lava_land_scroll":"lava_land","amw:purify_scroll":"purify","amw:self_rewind_scroll":"self_rewind","amw:flight_scroll":"flight","amw:astral_mount_scroll":"astral_mount","amw:blessing_scroll":"blessing","amw:burning_wall_scroll":"burning_wall","amw:devine_ascension_scroll":"devine_ascension","amw:dragon_breath_scroll":"dragon_breath","amw:fire_breath_scroll":"fire_breath","amw:machine_gun_arrow_scroll":"machine_gun_arrow","amw:air_vortex_scroll":"air_vortex","amw:wind_barrier_scroll":"wind_barrier","amw:invisible_bridge_scroll":"invisible_bridge","amw:spider_climb_scroll":"spider_climb","amw:enchance_vegetation_scroll":"enchance_vegetation","amw:snowball_burst_scroll":"snowball_burst","amw:light_source_scroll":"light_source","amw:bubble_rush_scroll":"bubble_rush","amw:throwing_ancor_scroll":"throwing_ancor","amw:charged_ancor_scroll":"charged_ancor","amw:ice_branch_scroll":"ice_branch","amw:ice_shard_scroll":"ice_shard","amw:shepherd_scroll":"shepherd","amw:undead_army_scroll":"undead_army","amw:skull_army_scroll":"skull_army","amw:vex_army_scroll":"vex_army","amw:bees_army_scroll":"bees_army","amw:zombie_servant_scroll":"zombie_servant","amw:iron_golem_guard_scroll":"iron_golem_guard","amw:skeleton_servant_scroll":"skeleton_servant","amw:ice_sculpture_scroll":"ice_sculpture","amw:light_judgement_scroll":"light_judgement","amw:entangled_scroll":"entangled","amw:possesion_scroll":"possesion","amw:telekenesis_scroll":"telekenesis","amw:atomic_hole_scroll":"atomic_hole","amw:atomic_destruction_scroll":"atomic_destruction","amw:fireball_scroll":"fireball","amw:water_bomb_scroll":"water_bomb","amw:ice_bounce_scroll":"ice_bounce","amw:icicle_scroll":"icicle","amw:icicle_bomb_scroll":"icicle_bomb","amw:burning_heals_scroll":"burning_heals","amw:fireflies_soul_scroll":"fireflies_soul","amw:fire_bullet_scroll":"fire_bullet","amw:bubble_trap_scroll":"bubble_trap","amw:water_pudding_scroll":"water_pudding","amw:toxic_flood_scroll":"toxic_flood","amw:toxic_step_scroll":"toxic_step","amw:tentacle_area_scroll":"tentacle_area","amw:tentacle_scroll":"tentacle","amw:leviathan_aura_scroll":"leviathan_aura","amw:multiple_fire_bullet_scroll":"multiple_fire_bullet","amw:void_swarm_scroll":"void_swarm","amw:arrow_burst_scroll":"arrow_burst","amw:burst_of_light_scroll":"burst_of_light","amw:meteor_rain_scroll":"meteor_rain","amw:scorch_scroll":"scorch","amw:lightning_bolt_scroll":"lightning_bolt","amw:sacred_hammer_scroll":"sacred_hammer","amw:thunder_streak_scroll":"thunder_streak","amw:evoker_fang_scroll":"evoker_fang","amw:fang_aura_scroll":"fang_aura","amw:greater_evoker_fang_scroll":"greater_evoker_fang","amw:fang_buffer_scroll":"fang_buffer","amw:wind_blows_scroll":"wind_blows","amw:wind_projectile_scroll":"wind_projectile","amw:orb_of_thunder_scroll":"orb_of_thunder","amw:blast_force_scroll":"blast_force","amw:frostbite_scroll":"frostbite","amw:blink_scroll":"blink","amw:swap_teleportation_scroll":"swap_teleportation","amw:alternate_damage_scroll":"alternate_damage","amw:teleport_scroll":"teleport","amw:warp_scroll":"warp","amw:chaining_tnt_scroll":"chaining_tnt","amw:exploding_tnt_scroll":"exploding_tnt","amw:convert_soul_scroll":"convert_soul","amw:light_beam_scroll":"light_beam","amw:poltergeist_scroll":"poltergeist","amw:tornado_scroll":"tornado","amw:thundering_arrow_scroll":"thundering_arrow","amw:ice_glace_scroll":"ice_glace","amw:gravity_pull_arrow_scroll":"gravity_pull_arrow","amw:explosive_arrow_scroll":"explosive_arrow","amw:healing_arrow_scroll":"healing_arrow","amw:gusting_arrow_scroll":"gusting_arrow","amw:scorching_shoot_scroll":"scorching_shoot","amw:armadillo_spinner_scroll":"armadillo_spinner","amw:targeting_shoot_scroll":"targeting_shoot","amw:aqua_surfing_scroll":"aqua_surfing","amw:portals_scroll":"portals","amw:wind_whirl_scroll":"wind_whirl","amw:electrocute_scroll":"electrocute","amw:gravity_pull_attack_scroll":"gravity_pull_attack","amw:burning_slash_scroll":"burning_slash","amw:chain_damage_scroll":"chain_damage","amw:poisonus_attack_scroll":"poisonus_attack","amw:provoke_scroll":"provoke","amw:ricochet_trident_scroll":"ricochet_trident","amw:everlasting_jump_scroll":"everlasting_jump","amw:arrow_rain_scroll":"arrow_rain","amw:dimensional_stash_scroll":"dimensional_stash","amw:wind_charge_scroll":"wind_charge"};

NoveltyManager.registerAccessoriesItem("amw:book_of_dharma", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:holy_book", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:alchemist_journal_part_2", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:book_of_witchcraft", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:manuscript", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:naturalist_guidance", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:pyromancer_spell_book", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:sacred_book", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:sorcerer_spell_book", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:theory_of_darkness", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:wicked_book", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:wizard_knowledge_volume_2", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:zeus_archive_book", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:basic_spell_book", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:grimore", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:summoner_tale", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:wizard_knowledge_volume_1", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:magic_research_book", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:alchemist_journal_part_1", AccessoriesSlot.Spellbook);
NoveltyManager.registerAccessoriesItem("amw:wizard_ring", AccessoriesSlot.Trinket);
NoveltyManager.registerAccessoriesItem("amw:soul_catcher_ring", AccessoriesSlot.Trinket);

export var predefine_attributes = {
	"amw:book_of_dharma": {
		light_magic: 1
	},
	"amw:holy_book": {
		soul_capacity: 15,
		light_magic: 2
	},
	"amw:alchemist_journal_part_2": {
		soul_capacity: 15
	},
	"amw:book_of_witchcraft": {
		dark_magic: 1
	},
	"amw:manuscript": {
		soul_capacity: 55
	},
	"amw:naturalist_guidance": {
		soul_capacity: 5,
		nature_magic: 1
	},
	"amw:pyromancer_spell_book": {
		soul_capacity: 25,
		fire_magic: 2
	},
	"amw:sacred_book": {
		soul_capacity: 5,
		dark_magic: 1,
		light_magic: 1
	},
	"amw:sorcerer_spell_book": {
		soul_capacity: 35
	},
	"amw:theory_of_darkness": {
		soul_capacity: 5,
		dark_magic: 1,
		void_magic: 1
	},
	"amw:wicked_book": {
		dark_magic: 1
	},
	"amw:wizard_knowledge_volume_2": {
		soul_capacity: 15
	},
	"amw:zeus_archive_book": {
		soul_capacity: 10,
		thunder_magic: 2
	}
};

export var predefine_spell_book = {
	// "amw:pyromancer_spell_book": {
	// 	locked_spell: [ 0 ],
	// 	spell: [
	// 		"fire_bullet"
	// 	]
	// }
};

export var attribute_point = {
	"amw:wand": 5,
	"amw:lapis_lazuli_wand": 10,
	"amw:angelic_wand": 10,
	"amw:amethyst_wand": 20,
	"amw:holy_staff": 15,
	"amw:redstone_staff": 15,
	"amw:satanic_staff": 25,
	"amw:staff": 5,
	"amw:amethyst_staff": 20,
	"amw:spellsword": 15,
	"amw:training_spellsword": 5,

	"amw:basic_spell_book": 10,
	"amw:grimore": 20,
	"amw:sacred_book": 30,
	"amw:manuscript": 40,
	"amw:theory_of_darkness": 40,
	"amw:book_of_dharma": 20,
	"amw:book_of_witchcraft": 30,
	"amw:summoner_tale": 20,
	"amw:wizard_knowledge_volume_1": 20,
	"amw:wizard_knowledge_volume_2": 30,
	"amw:pyromancer_spell_book": 40,
	"amw:magic_research_book": 10,
	"amw:holy_book": 20,
	"amw:sorcerer_spell_book": 40,
	"amw:alchemist_journal_part_1": 20,
	"amw:alchemist_journal_part_2": 30,
	"amw:wicked_book": 30,
	"amw:naturalist_guidance": 30,
	"amw:zeus_archive_book": 40,
	
	"amw:wizard_ring": 15,
	"amw:soul_catcher_ring": 5,
	"amw:mage_boots": 10,
	"amw:mage_leggings": 10,
	"amw:mage_robe": 10,
	"amw:mage_hat": 10,
	"amw:battlemage_boots": 20,
	"amw:battlemage_leggings": 20,
	"amw:battlemage_robe": 20,
	"amw:battlemage_hat": 20
};

export var cast_weapon = {
	"amw:wand": {
		cast_efficiency: 1.5,
		soul_efficiency: 2,
		"fast_swap": {}
	},
	"amw:lapis_lazuli_wand": {
		cast_efficiency: 1.1,
		soul_efficiency: 1.7,
		"fast_swap": {}
	},
	"amw:angelic_wand": {
		cast_efficiency: 0.9,
		soul_efficiency: 1.5,
		"fast_swap": {}
	},
	"amw:amethyst_wand": {
		cast_efficiency: 0.8,
		soul_efficiency: 1.2,
		"fast_swap": {}
	},
	"amw:holy_staff": {
		cast_efficiency: 1.9,
		soul_efficiency: 0.9
	},
	"amw:redstone_staff": {
		cast_efficiency: 2.5,
		soul_efficiency: 0.8
	},
	"amw:satanic_staff": {
		cast_efficiency: 0.9,
		soul_efficiency: 0.7
	},
	"amw:staff": {
		cast_efficiency: 2.7,
		soul_efficiency: 1.0
	},
	"amw:amethyst_staff": {
		cast_efficiency: 1.7,
		soul_efficiency: 0.6
	},
	"amw:spellsword": {
		cast_efficiency: 1.3,
		soul_efficiency: 1.0
	},
	"amw:training_spellsword": {
		cast_efficiency: 2.4,
		soul_efficiency: 1.8
	}
};

export var spell_book = {
	"amw:basic_spell_book": {
		path: "textures/items/basic_spell_book",
		name: "Basic Spell Book",
		max_spell: 1,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"transmutation",
			"manipulation"
		],
		compatible_types: [
			"action",
			"curse",
			"create",
			"enchance",
			"summon",
			"combat"
		],
		incompatible_attributes: [],
		grade: [ 0, 0 ] 

	},
	"amw:grimore": {
		path: "textures/items/spell_book/grimore",
		name: "Grimore",
		max_spell: 5,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"transmutation",
			"manipulation",
			"nature",
			"fire", 
			"void", 
			"dark",
			"light",
			"ice",
			"thunder",
			"water"
		],
		compatible_types: [
			"action",
			"curse",
			"create",
			"enchance",
			"summon",
			"combat"
		],
		incompatible_attributes: [],
		grade: [ 0, 3 ] 

	},
	"amw:sacred_book": {
		path: "textures/items/spell_book/sacred_book",
		name: "Sacred Book",
		max_spell: 8,
		compatible_attributes: [
			"dark",
			"light"
		],
		incompatible_attributes: [
			"restoration"
		],
		compatible_types: [
			"action",
			"curse",
			"create",
			"enchance",
			"summon"
		],
		grade: [ 1, 3 ] 
	},
	"amw:manuscript": {
		path: "textures/items/spell_book/manuscript",
		name: "Manuscript",
		max_spell: 9,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"manipulation",
			"transmutation"
		],
		incompatible_attributes: [],
		compatible_types: [
			"action",
			"curse",
			"create",
			"enchance",
			"summon",
			"combat"
		],
		grade: [ 3, 4 ] 
	},
	"amw:theory_of_darkness": {
		path: "textures/items/spell_book/theory_of_darkness",
		name: "Theory of Darkness",
		max_spell: 7,
		compatible_attributes: [
			"dark",
			"void"
		],
		incompatible_attributes: [
			"nature",
			"fire",
			"light",
			"ice"
		],
		compatible_types: [
			"action",
			"curse",
			"create",
			"enchance",
			"summon",
			"combat"
		],
		grade: [ 0, 3 ] 
	},
	"amw:book_of_dharma": {
		path: "textures/items/spell_book/book_of_dharma",
		name: "Book of Dharma",
		max_spell: 6,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration"
		],
		incompatible_attributes: [
			"destruction",
			"dark",
			"transmutation"
		],
		compatible_types: [
			"action",
			"create",
			"enchance",
			"summon",
			"combat"
		],
		grade: [ 0, 3 ] 
	},
	"amw:book_of_witchcraft": {
		path: "textures/items/spell_book/book_of_witchcraft",
		name: "Book of Witchcraft",
		max_spell: 3,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"transmutation"
		],
		incompatible_attributes: [
		],
		compatible_types: [
			"curse"
		],
		grade: [ 0, 2 ] 
	},
	"amw:summoner_tale": {
		path: "textures/items/spell_book/summoner_tale",
		name: "Summoner's Tale",
		max_spell: 3,
		compatible_attributes: [
			"creation",
			"conjuration"
		],
		incompatible_attributes: [
			"destruction",
			"restoration"
		],
		compatible_types: [
			"summon"
		],
		grade: [ 0, 2 ] 
	},
	"amw:wizard_knowledge_volume_1": {
		path: "textures/items/spell_book/wizard_knowledge_volume_1",
		name: "Wizard Knowledge Vol.1",
		max_spell: 3,
		compatible_attributes: [
			"creation",
			"conjuration",
			"destruction",
			"transmutation",
			"restoration"
		],
		incompatible_attributes: [
		],
		compatible_types: [
			"action"
		],
		grade: [ 0, 2 ] 
	},
	"amw:wizard_knowledge_volume_2": {
		path: "textures/items/spell_book/wizard_knowledge_volume_2",
		name: "Wizard Knowledge Vol.2",
		max_spell: 6,
		compatible_attributes: [
			"creation",
			"conjuration",
			"destruction",
			"restoration",
			"transmutation"
		],
		incompatible_attributes: [
		],
		compatible_types: [
			"action"
		],
		grade: [ 0, 3 ] 
	},
	"amw:pyromancer_spell_book": {
		path: "textures/items/spell_book/pyromancer_spell_book",
		name: "Pyromancer Spell Book",
		max_spell: 7,
		compatible_attributes: [
			"fire"
		],
		incompatible_attributes: [
		],
		compatible_types: [
			"action",
			"curse",
			"create",
			"enchance",
			"summon",
			"combat"
		],
		grade: [ 0, 3 ] 
	},
	"amw:magic_research_book": {
		path: "textures/items/spell_book/magic_research_book",
		name: "Magic Research Book",
		max_spell: 3,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"transmutation"
		],
		incompatible_attributes: [
		],
		compatible_types: [
			"action",
			"curse",
			"create",
			"enchance",
			"summon",
			"combat"
		],
		grade: [ 0, 1 ] 
	},
	"amw:holy_book": {
		path: "textures/items/spell_book/holy_book",
		name: "Holy Book",
		max_spell: 9,
		compatible_attributes: [
			"restoration",
			"light"
		],
		incompatible_attributes: [
			"destruction",
			"dark",
			"void"
		],
		compatible_types: [
			"enchance",
			"create",
			"summon"
		],
		grade: [ 0, 4 ] 
	},
	"amw:sorcerer_spell_book": {
		path: "textures/items/spell_book/sorcerer_spell_book",
		name: "Sorcerer's Spell Book",
		max_spell: 8,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"transmutation"
		],
		incompatible_attributes: [
		],
		compatible_types: [
			"enchance",
			"action",
			"create"
		],
		grade: [ 1, 3 ] 
	},
	"amw:alchemist_journal_part_1": {
		path: "textures/items/spell_book/alchemist_journal_part_1",
		name: "Alchemist Journal Pt.1",
		max_spell: 3,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"transmutation"
		],
		incompatible_attributes: [
			"destruction",
			"restoration"
		],
		compatible_types: [
			"create"
		],
		grade: [ 0, 2 ] 
	},
	"amw:alchemist_journal_part_2": {
		path: "textures/items/spell_book/alchemist_journal_part_2",
		name: "Alchemist Journal Pt.2",
		max_spell: 6,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"transmutation"
		],
		incompatible_attributes: [
		],
		compatible_types: [
			"create"
		],
		grade: [ 0, 3 ] 
	},
	"amw:wicked_book": {
		path: "textures/items/spell_book/wicked_book",
		name: "Wicked Book",
		max_spell: 5,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"transmutation",
			"manipulation"
		],
		incompatible_attributes: [
		],
		compatible_types: [
			"action",
			"curse",
			"enchance"
		],
		grade: [ 0, 3 ] 
	},
	"amw:naturalist_guidance": {
		path: "textures/items/spell_book/naturalist_guidance",
		name: "Naturalist Guidance",
		max_spell: 5,
		compatible_attributes: [
			"nature"
		],
		incompatible_attributes: [
		],
		compatible_types: [
			"action",
			"curse",
			"create",
			"enchance",
			"summon",
			"combat"
		],
		grade: [ 0, 2 ] 
	},
	"amw:zeus_archive_book": {
		path: "textures/items/spell_book/zeus_archive_book",
		name: "Zeus Archive Book",
		max_spell: 9,
		compatible_attributes: [
			"thunder"
		],
		incompatible_attributes: [
		],
		compatible_types: [
			"action",
			"curse",
			"create",
			"enchance",
			"summon",
			"combat"
		],
		grade: [ 0, 4 ] 
	},
	"amw:spellsword": {
		path: "textures/items/spellsword",
		name: "Spellsword",
		max_spell: 3,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"transmutation",
			"manipulation",
			"nature",
			"fire", 
			"void", 
			"dark",
			"light",
			"ice",
			"thunder"
		],
		compatible_types: [
			"action",
			"curse",
			"create",
			"enchance",
			"summon",
			"combat"
		],
		incompatible_attributes: [],
		grade: [ 0, 3 ] 

	},
	"amw:training_spellsword": {
		path: "textures/items/training_spellsword",
		name: "Training Spellsword",
		max_spell: 1,
		compatible_attributes: [
			"creation",
			"restoration",
			"conjuration",
			"destruction",
			"transmutation",
			"manipulation"
		],
		compatible_types: [
			"action",
			"create",
			"combat"
		],
		incompatible_attributes: [],
		grade: [ 0, 1 ] 

	}
}

export function getScrolls(){
	return scroll;
}

export function getPredefineAttributes(){
	return predefine_attributes;
}

export function getPredefineSpellBooks(){
	return predefine_spell_book;
}

export function getAttributePoint(){
	return attribute_point;
}

export function getCastWeapons(){
	return cast_weapon;
}

export function getSpellBooks(){
	return spell_book;
}


let compiled_data = {};

system.afterEvents.scriptEventReceive.subscribe(s=>{
    if(compiled_data[s.id]){
        compiled_data[s.id] += s.message;
    }else{
        compiled_data[s.id] = s.message;
    }
    
    try{
        let data = JSON.parse(compiled_data[s.id]);
		let scan_spellbook = false;

		for(let id of Object.keys(data.spell_book)){
			let spellbook_data = data.spell_book[id];
			if(spellbook_data.predefine){
				predefine_spell_book[id] = spellbook_data.predefine;
				spell_book[id] = spellbook_data;
				delete spell_book[id].predefine;
			}else{
				spell_book[id] = spellbook_data;
			}
			scan_spellbook = true;
		}

		for(let id of Object.keys(data.casting_weapon)){
			let casting_weapon_data = data.casting_weapon[id];
			cast_weapon[id] = {
				soul_efficiency: casting_weapon_data.soul_efficiency,
				cast_efficiency: casting_weapon_data.cast_efficiency,
			}
			if(casting_weapon_data.fast_swap){
				cast_weapon[id].fast_swap = {};
			}
		}

		for(let id of Object.keys(data.magic_attributes)){
			attribute_point[id] = data.magic_attributes[id];
		}

		for(let id of Object.keys(data.predefine_attributes)){
			predefine_attributes[id] = data.predefine_attributes[id];
		}

		for(let id of Object.keys(data.magic)){
			importMagicData(id, data.magic[id]);
			scroll[data.magic[id].item_type] = id;
			updateMagicLearningStation();
			updateSpellRecipes();
			updateSpellBindingTable();
		}

		if(scan_spellbook) updateReinforcementTable();

        delete compiled_data[s.id];
        console.log("[MagicDatabase] Successful add data to database");
    }catch(error){
        console.log("[MagicDatabase] Compiling data...");
    }
}, { namespaces: [ "amw_load_database" ]})
